<template>
    <div class="collectSeedLog">
        <h2 style="margin-bottom: 20px;padding-bottom:7px;border-bottom:2px solid #ddd">批次管理</h2>
        <header id="header">
            <el-row type="flex" :gutter="20">
                <el-col :span="4">
                    <el-input v-model="search" placeholder="请输入"></el-input>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="getBatchList">查找</el-button>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="add">新增</el-button>
                </el-col>
            </el-row>
        </header>
        <section>
            <article class="table">
                <el-table
                    :data="tableData"
                    tooltip-effect="dark"
                    style="width: 100%"
                >
                    <el-table-column prop="id" label="序号"></el-table-column>
                    <el-table-column prop="batchNo" label="批次编码"></el-table-column>
                    <el-table-column prop="created" label="生成时间"></el-table-column>
                    <el-table-column prop="number" label="羊只数量"></el-table-column>
                    <el-table-column prop="avgWeight" label="平均体重(kg)"></el-table-column>
                    <el-table-column prop="avgDay" label="平均日龄"></el-table-column>
                    <el-table-column prop="position" label="当前位置"></el-table-column>
                    <el-table-column label="操作人">
                        <template v-slot="scope">
                            <div v-for="item in $store.state['workerList']" :key="item.value">
                                <span v-if="item.id == scope.row['feeder']">{{ `${item.name}(${item.position})` }}</span>
                            </div>
                        </template>
                    </el-table-column>
                </el-table>

                <el-row type="flex" justify="end">
                    <el-col :span="8" class="pagination">
                        <el-pagination
                            @current-change="pageChange"
                            background
                            layout="prev, pager, next"
                            :page-count="Number(totalPages)"
                        ></el-pagination>
                    </el-col>
                </el-row>
            </article>
        </section>

        <el-dialog title="新增/编辑" :visible.sync="isShow" width="40%">
            <el-row type="flex">
                <el-col :span="20">
                    <el-form ref="addBatch" :model="formData" :rules="rules" label-width="140px">
                        <el-form-item label="种公羊编号">
                            <el-input v-model="formData.sheepIds"></el-input>
                        </el-form-item>
                        <el-form-item label="操作人">
                            <el-select v-model="formData.feeder" filterable placeholder="请选择">
                                <el-option
                                    v-for="item in $store.state['workerList']"
                                    :key="item.id"
                                    :label="`${item.name}(${item.position})`"
                                    :value="item.id"
                                ></el-option>
                            </el-select>
                        </el-form-item>
                        <el-form-item>
                            <el-button @click="isShow=false">取 消</el-button>
                            <el-button type="primary" @click="submitForm('addBatch')">保 存</el-button>
                        </el-form-item>
                    </el-form>
                </el-col>
            </el-row>
        </el-dialog>
    </div>
</template>

<script>
import {
    reqBatchList,
    reqAddBatch,
    reqDelBatch
} from "@/api/production.js";

const pageSize = 10;
const rules = {};

export default {
    name: "collectSeedLog",
    data() {
        return {
            search: "",
            pageNum: 1,
            tableData: [],
            totalPages: 0,
            isShow: false,
            formData: {
                sheepIds: "12,123,568,454,456",
                feeder: null
            },
            rules
        };
    },
    created() {
        // 入库管理列表
        this.getBatchList();
    },
    methods: {
        submitForm(formName) {
            this.$refs[formName].validate(valid => {
                if (valid) {
                    reqAddBatch(this.formData)
                        .then(res => {
                            // 入库管理列表
                            this.getBatchList();
                            this.$message.success("成功！");
                            // this.isShow = false
                        })
                        .catch(err => {
                            console.log(err);
                            this.$message.error("失败！");
                        });
                } else {
                    return false;
                }
            });
        },
        // 入库管理列表
        getBatchList() {
            reqBatchList({
                searchStr: this.search,
                pageSize,
                pageNum: this.pageNum
            })
                .then(res => {
                    this.tableData = res.content;
                    this.totalPages = res.totalPages;
                })
                .catch(err => {
                    console.log(err);
                });
        },
        add() {
            this.isShow = true;
            // 有id是update 没id是add
            delete this.formData.id;
        },
        edit(row) {
            this.formData = row;
            this.isShow = true;
        },
        del(row) {
            reqDelBatch(row.id)
                .then(res => {
                    // 入库管理列表
                    this.getBatchList();
                    if (res.code == "success") {
                        this.$message.success(res.msg);
                    }
                    if (res.errCode == "delete failed") {
                        this.$message.error(res.errMsg);
                    }
                })
                .catch(err => {
                    console.log(err);
                    this.$message.error("删除失败！");
                });
        },
        pageChange(p) {
            console.log(p);
            this.pageNum = p;
            // 入库管理列表
            this.getBatchList();
        }
    }
};
</script>

<style lang="scss" scoped>
#header {
    margin-bottom: 15px;
}
.table {
    .pagination {
        margin-top: 20px;
    }
}
</style>